import os, sys, re, stat, time, string, codecs, commands, shutil, subprocess
from drag_drop import XDSLoader
from buffer import Buffer
import _dialogs
import gtk
import encodings.utf_8
import ConfigParser
import mimetypes

try:
	import gtksourceview2
except:
	print >> sys.stdout, "Cannot load gtksourceview2"
	dlg = gtk.MessageDialog(None, gtk.DIALOG_DESTROY_WITH_PARENT,
		gtk.MESSAGE_ERROR, gtk.BUTTONS_OK,
 		"Cannot load gtksourceview2!\n\nthe gtksourceview2 widget is required by HTMLpage.\nThe program will now exit...\n")
	resp = dlg.run()
	dlg.hide()
	raise SystemExit

try:
	import pango
except:
	print >> sys.stdout, "Cannot load Pango"
	dlg = gtk.MessageDialog(None, gtk.DIALOG_DESTROY_WITH_PARENT,
		gtk.MESSAGE_ERROR, gtk.BUTTONS_OK,
 		"Cannot load pango!\n\nPango is required by HTMLpage.\nThe program will now exit...\n")
	resp = dlg.run()
	dlg.hide()
	raise SystemExit
	
config = ConfigParser.ConfigParser()
samp_config = os.path.join(os.path.dirname(os.path.realpath(sys.argv[0])), "HTMLpage.cfg")
cfile = os.path.join(os.path.expanduser("~/"), ".HTMLpage")
if not os.path.exists(cfile):
	shutil.copyfile(samp_config, cfile)
config.read(cfile)

default_font = config.get("defaults", "default_font")
background_colour = config.get("defaults", "background_colour")
foreground_colour = config.get("defaults", "foreground_colour")

prog_cmd = commands.getoutput('which htmlpage')
BLOCK_SIZE = 1024
to_utf8 = codecs.getencoder('utf-8')
curPathStream = ["", ""]

known_codecs = (
	"iso8859_1", "iso8859_2", "iso8859_3", "iso8859_4", "iso8859_5",
	"iso8859_6", "iso8859_7", "iso8859_8", "iso8859_9", "iso8859_10",
	"iso8859_13", "iso8859_14", "iso8859_15",
	"ascii", "base64_codec", "charmap",
	"cp037", "cp1006", "cp1026", "cp1140", "cp1250", "cp1251", "cp1252",
	"cp1253", "cp1254", "cp1255", "cp1256", "cp1257", "cp1258", "cp424",
	"cp437", "cp500", "cp737", "cp775", "cp850", "cp852", "cp855", "cp856",
	"cp857", "cp860", "cp861", "cp862", "cp863", "cp864", "cp865", "cp866",
	"cp869", "cp874", "cp875", "hex_codec",
	"koi8_r",
	"latin_1",
	"mac_cyrillic", "mac_greek", "mac_iceland", "mac_latin2", "mac_roman", "mac_turkish",
	"mbcs", "quopri_codec", "raw_unicode_escape",
	"rot_13",
	"utf_16_be", "utf_16_le", "utf_16", "utf_7", "utf_8", "uu_codec",
	"zlib_codec"
)



htmlpage_xpm = [
"16 16 124 2",
"  	c None",
". 	c #A6630C",
"+ 	c #804800",
"@ 	c #FEFDFC",
"# 	c #EED9BE",
"$ 	c #EDD8BD",
"% 	c #F0DDC4",
"& 	c #F2E1CA",
"* 	c #CD9A59",
"= 	c #CF9E5F",
"- 	c #D09F60",
"; 	c #F0DFC8",
"> 	c #90A1B8",
", 	c #5F80AD",
"' 	c #4F77AD",
") 	c #4C75AC",
"! 	c #5078AE",
"~ 	c #57769F",
"{ 	c #DDB683",
"] 	c #5B7FB1",
"^ 	c #7595C1",
"/ 	c #B0C4DC",
"( 	c #D2DEEC",
"_ 	c #DBE3F3",
": 	c #C9D8EB",
"< 	c #A5BDD9",
"[ 	c #7092C0",
"} 	c #4B74AB",
"| 	c #BF8539",
"1 	c #5179AF",
"2 	c #A4BAD8",
"3 	c #D7DFE9",
"4 	c #C5D3E1",
"5 	c #B3BAC1",
"6 	c #B3C6DB",
"7 	c #AECFF0",
"8 	c #B4C5D6",
"9 	c #CEDBE8",
"0 	c #96B1D2",
"a 	c #6184B3",
"b 	c #A3B9D7",
"c 	c #D6DCE4",
"d 	c #C8CDD0",
"e 	c #D5E9FF",
"f 	c #CFE8FF",
"g 	c #C4DFFA",
"h 	c #B2C3D4",
"i 	c #B8C0CC",
"j 	c #D4D9DC",
"k 	c #DDE5ED",
"l 	c #899BB5",
"m 	c #7396C1",
"n 	c #E6EEF6",
"o 	c #DDDEDF",
"p 	c #C0D0DE",
"q 	c #D7ECFF",
"r 	c #D7EBFF",
"s 	c #C9E4FF",
"t 	c #BDCAD7",
"u 	c #D0D3D6",
"v 	c #EEEEF0",
"w 	c #BECCDF",
"x 	c #6D8FB9",
"y 	c #A9BFDB",
"z 	c #D9DEDF",
"A 	c #BDD8F3",
"B 	c #D5EAFF",
"C 	c #CBE5FF",
"D 	c #C0C9D0",
"E 	c #B5C2CF",
"F 	c #98B0CC",
"G 	c #ADB9C7",
"H 	c #537BB1",
"I 	c #C9D7E9",
"J 	c #9DBAD7",
"K 	c #BBDDFF",
"L 	c #D3E9FF",
"M 	c #C0D5EC",
"N 	c #F7F7F7",
"O 	c #F8F8F8",
"P 	c #AEBED3",
"Q 	c #4D75AB",
"R 	c #CFDDEF",
"S 	c #9AC5F2",
"T 	c #A8D1FA",
"U 	c #B7DBFF",
"V 	c #C7E3FF",
"W 	c #C1E0FF",
"X 	c #C1CBD3",
"Y 	c #BDCBDE",
"Z 	c #507AAE",
"` 	c #C0D3E8",
" .	c #ADBDCD",
"..	c #C0C9D2",
"+.	c #A3C7EF",
"@.	c #A4CDF6",
"#.	c #A0CAF4",
"$.	c #9CB6D4",
"%.	c #F2F4F4",
"&.	c #EAECEE",
"*.	c #B7C5D8",
"=.	c #A35E05",
"-.	c #5779AB",
";.	c #9EB7D6",
">.	c #D4DCE2",
",.	c #D8DBDE",
"'.	c #91B7E1",
").	c #89B8E9",
"!.	c #80B0E6",
"~.	c #73A2D3",
"{.	c #7CA3CE",
"].	c #EFEFEF",
"^.	c #AFBDD0",
"/.	c #5375AD",
"(.	c #6B91BF",
"_.	c #A5BBD8",
":.	c #C0CEE0",
"<.	c #E6E8EA",
"[.	c #71A2D9",
"}.	c #6DA2DD",
"|.	c #619BD7",
"1.	c #5891D2",
"2.	c #DADADA",
"3.	c #A7B5C8",
". + + + + + + + + + + + +       ",
"+ @ @ @ @ @ @ @ @ @ @ @ @ +     ",
"+ @ # $ $ $ $ $ # # % & @ +     ",
"+ @ $ * = = = = = = - & @ +     ",
"+ @ $ $ $ # # # % % ; & @ +     ",
"+ @ $ = = = = = > , ' ) ! ~     ",
"+ @ $ $ # # { ] ^ / ( _ : < [ } ",
"+ @ $ = = | 1 2 3 4 5 6 7 8 9 0 ",
"+ @ # # % a b c d e f g h i j k ",
"+ @ # = l m n o p q r s t u v w ",
"+ @ # % x y z A B B B C D E F G ",
"+ @ % = H I J K L L L M N O N P ",
"+ @ % % Q R S T U V W X O O O Y ",
"+ @ @ @ Z `  ...+.@.#.$.%.&.O *.",
"=.+ + + -.;.>.O ,.'.).!.~.{.].^.",
"        /.(._.:.:.<.[.}.|.1.2.3."
]

ui_string = """<ui>
<toolbar name='Toolbar'>
	<toolitem action='Open'/>
	<toolitem action='Save'/>
	<toolitem action='Exit'/>
	<separator/>
	<toolitem action='Cut'/>
	<toolitem action='Copy'/>
	<toolitem action='Paste'/>
	<toolitem action='Undo'/>
	<toolitem action='Redo'/>
	<separator/>
	<toolitem action='Search'/>
	<toolitem action='Replace'/>
	<separator/>
	<toolitem action='Spellcheck'/>
	<toolitem action='HTML-ify'/>
	<toolitem action='TABLE-ify'/>
	<toolitem action='Color'/>
	<toolitem action='Help'/>
</toolbar>
<popup name='Popup'>
<menu action='FileMenu'>
	<menuitem action='New'/>
	<separator/>
	<menuitem action='Open'/>
	<menuitem action='Save'/>
	<menuitem action='Save As'/>
	<menuitem action='Close'/>	
</menu>
<menu action='EditMenu'>
	<menuitem action='Cut'/>
	<menuitem action='Copy'/>
	<menuitem action='Paste'/>
	<separator/>
	<menuitem action='Undo'/>
	<menuitem action='Redo'/>
	<separator/>
	<menuitem action='Search'/>
	<menuitem action='Replace'/>
	<menuitem action='Go To Line'/>
</menu>
<menu action='Insert'>
	<menuitem action='Break'/>
	<menuitem action='Quote'/>
	<menuitem action='NB Space'/>
	<menuitem action='Pre'/>
	<menuitem action='endPre'/>
	<menuitem action='Blockquote'/>
	<menuitem action='End Blockquote'/>
	<menuitem action='Center'/>
	<menuitem action='End Center'/>
	<menuitem action='Javascript'/>
	<menuitem action='Style Tag'/>
	<menuitem action='Date'/>
</menu>
<menu action='Special'>
	<menuitem action='Spellcheck'/>
	<menuitem action='Color'/>
	<menuitem action='HTML-ify'/>
	<menuitem action='TABLE-ify'/>
</menu>
<menu action='Options'>
	<menuitem action='Font'/>
	<menuitem action='BG Color'/>
	<menuitem action='FG Color'/>
</menu>
<menuitem action='Help'/>
</popup>
<popup name='Dropped'>
<menu action='Dropped file'>
	<menuitem action='Open in new window'/>
	<menuitem action='Create a Hyperlink'/>
	<menuitem action='Insert text at cursor'/>
</menu>
</popup>
</ui>"""

default_text = "<HTML>\n<HEAD>\n<TITLE>** Untitled Page **</TITLE>\n<META NAME=\"generator\" \
	CONTENT=\"HTMLpage\">\n</HEAD>\n<BODY>\n\n\n\n\n</BODY>\n</HTML>"
	
class Abort(Exception):
	pass

class Minibuffer:
	def setup(self):
		"""Called when the minibuffer is opened."""
	
	def key_press(self, kev):
		"""A keypress event in the minibuffer text entry."""
	
	def changed(self):
		"""The minibuffer text has changed."""
	
	def activate(self):
		"""Return or Enter pressed."""
	
	info = 'Press Escape to close the minibuffer.'


class EditWindow(gtk.Window, XDSLoader):
	def __init__(self, filename = None, data = None):
		gtk.Window.__init__(self)
		XDSLoader.__init__(self, ['text/plain', 'UTF8_STRING'])
		self.set_default_size(630, 372)
		self.set_geometry_hints(self, 630, 240, gtk.gdk.screen_width(), gtk.gdk.screen_height() - 60)
		icon = gtk.gdk.pixbuf_new_from_xpm_data(htmlpage_xpm)
		self.set_icon(icon)
 
		self.connect('delete-event', self.close)
		self.savebox = None
		self.info_box = None
		self.uri = ""
		self.buffer = gtksourceview2.Buffer()

		self.buffer.begin_not_undoable_action()
		
		lang = None
		if data:
			lang_manager = gtksourceview2.LanguageManager()
			language = lang_manager.get_language("html")
			self.buffer.set_language(language)
			self.buffer.set_highlight_syntax(True)
		else:	
			if filename != None:
			
				if self.getext(filename) == "html":
					lang_manager = gtksourceview2.LanguageManager()
					language = lang_manager.get_language("html")
					self.buffer.set_language(language)
					self.buffer.set_highlight_syntax(True)
			
				else:
					ext = os.path.splitext(filename)	

					if ext[1] == ".html" or ext[1] == ".htm":
						lang = "html"
					elif ext[1] == ".c" or ext[1] == ".h":
						lang = "c"
					elif ext[1] == ".cpp":
						lang = "cpp"
					elif ext[1] == ".pl" or ext[1] == ".cgi" or ext[1] == ".pm":
						lang = "perl"
					elif ext[1] == ".py":
						lang = "python"
					elif ext[1] == ".xml":
						lang = "xml"
					else:
						try:
							f = open(filename)
							rl = f.readline()
							f.close()
						except:
							pass
						if rl.rfind('#!/bin/bash') != -1 or rl.rfind('#!/bin/sh') != -1:
							lang = "sh"

					if lang != None:
						lang_manager = gtksourceview2.LanguageManager()
						language = lang_manager.get_language(lang)
						self.buffer.set_language(language)
						self.buffer.set_highlight_syntax(True)
				
			else:
				lang_manager = gtksourceview2.LanguageManager()
				language = lang_manager.get_language('html')
				self.buffer.set_language(language)
				self.buffer.set_highlight_syntax(True)


		# uncomment to change style, choose from classic, kate, oblivion, tango
		sc_mgr = gtksourceview2.style_scheme_manager_get_default()
		style_scheme = sc_mgr.get_scheme('absolute')
		if style_scheme:
			self.buffer.set_style_scheme(style_scheme)
		
		self.text = gtksourceview2.View(self.buffer)
		self.text.set_tab_width(4)
		self.text.set_indent_on_tab(True)
		
		# comment out next line if you DO NOT want line numbers
		self.text.set_show_line_numbers(True)
		
		self.text.set_size_request(10, 10)
		self.text.set_left_margin(8)
		self.text.set_right_margin(6)
		self.xds_proxy_for(self.text)
		self.update_styles()
		
		self.insert_mark = self.buffer.get_mark('insert')
		self.selection_bound_mark = self.buffer.get_mark('selection_bound')
		start = self.buffer.get_start_iter()
		self.mark_start = self.buffer.create_mark('mark_start', start, True)
		self.mark_end = self.buffer.create_mark('mark_end', start, False)
		self.mark_tmp = self.buffer.create_mark('mark_tmp', start, False)
		tag = self.buffer.create_tag('marked')
		tag.set_property('background', 'green')
		self.marked = 0

		# When searching, this is where the cursor was when the minibuffer
		# was opened.
		start = self.buffer.get_start_iter()
		self.search_base = self.buffer.create_mark('search_base', start, True)

		
############ START PACKING ###################################################################
		vbox = gtk.VBox()
		self.add(vbox)
		
		##### build the menus... regular, toolbar and 2 popups
		##### one popup for right-click (insert), the other to handle droped files

		self.create_ui()
				
		self.t_widge = self.ui.get_widget('/Toolbar')
		self.t_widge.set_style(gtk.TOOLBAR_ICONS)
		vbox.pack_start(self.t_widge, expand=False)
		
		popup = gtk.Menu()
		popup = self.ui.get_widget('/Popup')
		self.dropper = gtk.Menu()
		self.dropper = self.ui.get_widget('/Dropped')		
		
		# Add the line number(s) to the toolbar
		self.font_indicator = gtk.ToolItem()
		self.status_label = gtk.Label()
		self.font_indicator.add(self.status_label)
		self.status_label.set_size_request(80, -1)
		self.t_widge.insert(self.font_indicator, -1)			

		swin = gtk.ScrolledWindow()
		swin.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
		vbox.pack_start(swin, True, True)

		swin.add(self.text)
		self.show_all()

		if not filename and not data:
			self.buffer.insert_at_cursor(default_text)
		
		# Create the minibuffer
		self.mini_hbox = gtk.HBox(False)
		info = gtk.Button()
		info.set_relief(gtk.RELIEF_NONE)
		info.unset_flags(gtk.CAN_FOCUS)
		image = gtk.Image()
		image.set_from_stock(gtk.STOCK_DIALOG_INFO, size = gtk.ICON_SIZE_SMALL_TOOLBAR)
		info.add(image)
		info.show_all()
		info.connect('clicked', self.mini_show_info)

		self.mini_hbox.pack_start(info, False, True, 0)
		self.mini_label = gtk.Label('')
		self.mini_hbox.pack_start(self.mini_label, False, True, 0)
		self.mini_entry = gtk.Entry()
		self.mini_hbox.pack_start(self.mini_entry, True, True, 0)
		vbox.pack_start(self.mini_hbox, False, True)
		self.mini_entry.connect('key-press-event', self.mini_key_press)
		self.mini_entry.connect('changed', self.mini_changed)

		self.text.grab_focus()
		
		def update_current_line(*unused):
			cursor = self.buffer.get_iter_at_mark(self.insert_mark)
			bound = self.buffer.get_iter_at_mark(self.selection_bound_mark)
			if cursor.compare(bound) == 0:
				n_lines = self.buffer.get_line_count()
				self.status_label.set_text(('Line %s of %d') % (cursor.get_line() + 1, n_lines))
			else:
				n_lines = abs(cursor.get_line() - bound.get_line()) + 1
				if n_lines == 1:
					n_chars = abs(cursor.get_line_offset() - bound.get_line_offset())
					if n_chars == 1:
						bytes = to_utf8(self.buffer.get_text(cursor, bound, False))[0]
						self.status_label.set_text(('One character selected (%s)') %
							' '.join(map(lambda x: '0x%2x' % ord(x), bytes)))
					else:
						self.status_label.set_text(('%d characters selected') % n_chars)
				else:
					self.status_label.set_text(('%d lines selected') % n_lines)
					
					
		self.buffer.connect('mark-set', update_current_line)
		self.buffer.connect('changed', update_current_line)

		if filename and filename != '-':
			#import os.path
			self.uri = os.path.abspath(filename)
		else:
			self.uri = None
		self.update_title()
		# Loading might take a while, so get something on the screen, now...
		gtk.gdk.flush()
		if filename and filename != '-':
			try:
				ret = self.load_file(filename)
				if not ret: raise SystemExit
				if filename != '-':
					self.save_last_stat = os.stat(filename)
			except:
				# Harsh ending to failed new instance
				sys.exit()
		else:
			if data:
				contents = self.convert_to_utf8(data)
				self.insert_data(contents)	
				
				
					
			
		self.buffer.connect('modified-changed', self.update_title)
		self.buffer.set_modified(False)
		def button_press(text, event):
			if event.button != 3:
				return False
			popup.popup(None, None, None, event.button, event.time)
			return True
		self.text.connect('button-press-event', button_press)

		if filename:
			self.buffer.place_cursor(self.buffer.get_start_iter())
		else:
			iter = self.buffer.get_iter_at_line(7)
			self.buffer.place_cursor(iter)
		#self.buffer.start_undo_history()
		self.buffer.end_not_undoable_action()	

#############################################################################################################
###########################################  END OF INIT ####################################################	

	def get_magic(self, filename):
		pipe=subprocess.Popen(['file',filename],stdout=subprocess.PIPE)
		output = pipe.stdout.read()
		pipe.wait()
		return output

	def getext(self, filename):
		types = (
		('rtf', 'Rich Text Format data'),
		('doc', 'Microsoft Office Document'),
		('pdf', 'PDF'),
		('txt', 'ASCII English text'),
		('html', 'HTML'),
		)
		fileoutput = self.get_magic(filename)
		for ext, pattern in types:
			if pattern in fileoutput:
				return ext
				      
	def create_ui(self):
		ag = gtk.ActionGroup('WindowActions')
        	actions = [
        	    ('FileMenu', gtk.STOCK_FILE, '_File'),
        	    ('Open', gtk.STOCK_OPEN, 'Open', None, 'Open', self.open),
        	    ('Save', gtk.STOCK_SAVE, '_Save', None, 'Save', self.file_save),
		    ('Save As', gtk.STOCK_SAVE_AS, 'Save As', None, 'Save As', self.save_file_dialog),
        	    ('Close', gtk.STOCK_CLOSE, 'Close', None, 'Exit', self.close),
		    ('New', gtk.STOCK_NEW, 'New', None, 'Create a new file', self.newdoc),
		    ('EditMenu', gtk.STOCK_EDIT, '_Edit'),
		    ('Cut', gtk.STOCK_CUT, 'Cut', None, 'Cut', self.cut),
		    ('Copy', gtk.STOCK_COPY, 'Copy', None, 'Copy', self.copy),
		    ('Paste', gtk.STOCK_PASTE, 'Paste', None, 'Paste', self.paste),
		    ('Undo', gtk.STOCK_UNDO, 'Undo', None, 'Undo', self.undo),
		    ('Redo', gtk.STOCK_REDO, 'Redo', None, 'Redo', self.redo),
		    ('Search', gtk.STOCK_FIND, 'Search', None, 'Search', self.search),
		    ('Replace', gtk.STOCK_FIND_AND_REPLACE, 'Replace', None, 'Replace', self.search_replace),
		    ('Go To Line', gtk.STOCK_NEW, 'Go to Line', None, 'Go to Line', self.goto),
		    ('Help', gtk.STOCK_HELP, 'Help', None, 'Help', self.show_help),
		    ('Exit', gtk.STOCK_QUIT, 'Exit', None, 'Exit', self.close),
		    ('Spellcheck', gtk.STOCK_SPELL_CHECK, 'Spellcheck', None, 'Spellcheck', self.spellcheck),
		    ('Special', 'effect', '_Special'),
		    ('HTML-ify', gtk.STOCK_CONVERT, 'HTML-ify', None, 'HTML-ify', self.parseText),
		    ('TABLE-ify', "table", 'TABLE-ify', None, 'TABLE-ify', self.parseTable),
		    ('Color', gtk.STOCK_SELECT_COLOR, 'Color Tag', None, 'Color Tag', self.colorSelect),
		    ('Insert', 'insert', '_Insert'),
		    ('Break', gtk.STOCK_INDENT, 'Break', '<Ctrl>B', '<Ctrl>B', self.inBreak),
		    ('Quote', gtk.STOCK_INDENT, 'Quote', '<Ctrl>Q', '', self.inQuote),
		    ('NB Space', gtk.STOCK_INDENT, 'Spacer', '<Ctrl><alt>B', '', self.inSpace),
		    ('Blockquote', gtk.STOCK_INDENT, 'Blockquote', '<Ctrl>K', '', self.blkQuote),
		    ('Pre', gtk.STOCK_INDENT, 'Pre', '<Ctrl>P', '', self.inPre),
		    ('endPre', gtk.STOCK_INDENT, 'End Pre', '<Ctrl><alt>P', '', self.inPreEnd),
		    ('End Blockquote', gtk.STOCK_INDENT, 'End Blockquote', '<Ctrl><alt>K', '', self.blkQuoteEnd),
		    ('Center', gtk.STOCK_INDENT, 'Center', '<Ctrl><alt>C', '', self.blkCenter),
		    ('End Center', gtk.STOCK_INDENT, 'End Center', '<Ctrl><alt>V', '', self.blkCenterEnd),
		    ('Javascript', gtk.STOCK_INDENT, 'Javascript', '<Ctrl>J', '', self.java_script),
			('Style Tag', gtk.STOCK_INDENT, 'Style Tag', '', '', self.style_tag),
		    ('Date', 'calendar', 'Todays Date', None, '', self.print_date),
        	    ('Dropped file', None, 'Dropped file'),
        	    ('Open in new window', gtk.STOCK_NEW, 'Open in new window', None, None, self.dropOpen),
        	    ('Create a Hyperlink', gtk.STOCK_JUMP_TO, 'Create a Hyperlink', None, None, self.dropLink),
        	    ('Insert text at cursor', gtk.STOCK_COPY, 'Insert text at cursor', None, None, self.dropInsert),
		    ('Options', gtk.STOCK_PREFERENCES, 'Options'),
		    ('Font', gtk.STOCK_SELECT_FONT, 'Font', None, '', self.select_font),
		    ('FG Color', 'font_color', 'FG Color', None, '', self.txt_fg_color),
		    ('BG Color', 'bg_color', 'BG Color', None, '', self.txt_bg_color),
        	    ]
	    
        	ag.add_actions(actions)
        	self.ui = gtk.UIManager()
        	self.ui.insert_action_group(ag, 0)
        	self.ui.add_ui_from_string(ui_string)
        	self.add_accel_group(self.ui.get_accel_group())
		

	def update_styles(self):
		try:
			font = pango.FontDescription(default_font)
			bg = gtk.gdk.color_parse(background_colour)
			fg = gtk.gdk.color_parse(foreground_colour)
		except:
			pass
		else:
			self.text.modify_font(font)
			self.text.modify_base(gtk.STATE_NORMAL, bg)
			self.text.modify_text(gtk.STATE_NORMAL, fg)
		
		
	def cut(self, button = None): self.text.emit('cut_clipboard')
	def copy(self, button = None): self.text.emit('copy_clipboard')
	def paste(self, button = None): 
	
		#check for a selection, put in "mytext" if found
		if self.buffer.get_selection_bounds():
			start, end = self.buffer.get_selection_bounds()
			#do edit, making it "undo"-able
			self.buffer.begin_user_action()
			self.buffer.delete(start,end)
			###self.insert_data(fullstring)
			
			self.buffer.end_user_action()
			self.text.emit('paste_clipboard')
			
		else:			
			self.text.emit('paste_clipboard')
		
		
	def delete_event(self, window, event):
		if self.buffer.get_modified():
			self.file_save(self)
			return 1
		return 0

	def update_title(self, *unused):
		if self.uri:
			titlePre = "HTMLpage   " + self.uri
		else:
			titlePre = "HTMLpage    <Not Saved>"
		title = titlePre #self.uri or '<Untitled>'
		if self.buffer.get_modified():
			title = title + " *"
		self.set_title(title)
#*********************************************************************************************************
# LOADING OF DROPPED FILES
#*********************************************************************************************************
	def xds_load_from_stream(self, name, t, stream):
		self.r = None
		ctype, encoding = mimetypes.guess_type(name)
		#print ctype

		try:
		
			c = str(ctype)

			###### images first, as they are the most common :) ###########################
			if (c == "image/jpeg") or (c == "image/png") or (c == "image/gif"):
				print "is there"
				suffix = string.split( name, '.' )[-1]
				if not self.uri:
					_dialogs.alert('\nCannot generate a path to the image\nThis page must be saved somewhere first...')
					return
				myPath = self.getRelPath(name);
				width, height = self.get_img_dim(name)
				myTag = '<img src="%s" width="%i" height="%i" border=0>' % (myPath, width, height)
				self.insert_data(myTag)
				return
			
			##### then all linkable stuff ##################################################			
			if not self.istext(open(name).read(512)):
				self.make_url(name)
				return
			
			# take care of some text-based stuff that we link for now
			# until I include a converter	
			# PDFs
			if c == "application/pdf":
				self.make_url(name)
				return
			# PS
			if c == "application/postscript":
				self.make_url(name)
				return
			
			### and finally anything we have a choice of openning, inserting or linking ####					
			else:	
				curPathStream[0] = name
				curPathStream[1] = stream.read()
				self.dropper.popup(None, None, None, 0, 0)
		except Abort:
			pass
		
			
	def make_url(self, f):
		if not self.uri:
			_dialogs.alert('\nCannot create a hyperlink.\nThis page must be saved somewhere first...')
			return
		myPath = self.getRelPath(f);
		fPath, fname = os.path.split(myPath)
		myTag = "<A href=\"" + myPath + "\">" + fname + "</A>"
		self.insert_data(myTag)	
#***************************************************************************************************************
#next 3 functions process dropped files
#***************************************************************************************************************
	def dropOpen(self, event):
		curPathStream[1] = ""
		fName = curPathStream[0]
		# Bail if we get returned a Directory or a file which does not exist
		if os.path.isdir(fName) or not os.path.isfile(fName):
			return
		if not os.access(fName, os.W_OK):
			_dialogs.alert("You do not have write access to that file")
			return
		# skip the file-open vodoo here -- just pop open another edit window and pass the filename
		cmd = sys.argv[0]
		args = [cmd, fName]
		os.spawnv(os.P_NOWAIT, cmd, args)
		curPathStream[0] = ""
		
	def dropLink(self, event):
		if not self.uri:
			_dialogs.alert('file must be saved first...\n to generate relative paths')
			return
		curPathStream[1] = ""
		mName = curPathStream[0]
		myPath = self.getRelPath(mName)
		if string.count(mName,'/') > 0:
			fName = string.split(mName, '/' )[-1]
		else:
			fName = mName
		self.insert_data("<A href=\"" + myPath + "\">" + fName + "</A>")
		curPathStream[0] = ""
		
	def dropInsert(self, event):
		try:
			self.insert_data(curPathStream[1])
		except Abort:
			pass
		curPathStream[0] = ""
		curPathStream[1] = ""
		
#***********************************************************************************************************
#spellchecker -- works on selected text
#***********************************************************************************************************
	def spellcheck(self, button=None):
		# find aspell, bail if not found
		myaspell = commands.getoutput('which aspell')
		if not myaspell:
			_dialogs.alert("aspell needs to be installed for the spell checker to function")
			return
		aspellCmd = myaspell + " -H"
		#check for a selection, put in "mytext" if found
		if not self.buffer.get_selection_bounds():
			_dialogs.alert("No text has been selected...\n\nthe spell function will check highlighted \ntext, not the entire document.")
			return
		start, end = self.buffer.get_selection_bounds()
		mytext = self.buffer.get_text(start,end)
		if len(mytext) < 2:
			_dialogs.alert("Not much to check...")
			return
		#my way to preserve carriage returns :)
		mytext = string.replace(mytext, "\n", " iiii ")
		ws_split = re.compile("\s+").split
		END_SIGNS = ".?!,"
		is_engword = re.compile("^[a-zA-Z]+$").match
		allwords = []
		for word in ws_split(mytext):
			if word == "iiii":
				allwords.append("\n")
				continue
			endsign = ""
			#strips off endsign
			if word and (word[-1] in END_SIGNS):
				endsign = word[-1]
				word = word[:-1]
			#checks if english
			if not is_engword(word):
				allwords.append(word + endsign)
				continue
			fo = os.popen("echo %s | %s -a" % (word, aspellCmd))
			fo.readline() # Ignore header line
			tmp = fo.readline().strip()
			if tmp == "*": # spelling is OK
				allwords.append(word + endsign)
				continue
			else: #first, get the list of suggestions
				tmplist = string.split(tmp, ':', 1)[-1]
				slist = string.split(tmplist, ',')
				#strip spaces from the suggestions
				suggestlist = []
				for current in slist:
					suggestlist.append(current.strip())
					
			#we have a list of suggestions for the misspelled "word", so get user's choice
			dlg = gtk.Dialog('Spell Checking')
			dlg.set_transient_for(self)
			dlg.show()

			lblchange = gtk.Label("Change the spelling for \"" + word + "\"?")
			lblchange.show()
			dlg.vbox.pack_start(lblchange, False, False, 8)


			#combo = gtk.Combo()
			#combo.set_popdown_strings(suggestlist)
			combo = gtk.combo_box_new_text()
			for l in suggestlist:
				combo.append_text(l)
                	combo.set_active(0)
			
			
			combo.show()
			dlg.vbox.pack_start(combo, False, False, 6)
			
			dlg.add_button(gtk.STOCK_OK, gtk.RESPONSE_OK)
			dlg.add_button(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL)
			dlg.set_default_response(gtk.RESPONSE_CANCEL)
			response = dlg.run()
			if response == gtk.RESPONSE_OK:
				mstr = self.get_active_text(combo)
				allwords.append(mstr + endsign)
			else:
				allwords.append(word + endsign)
			dlg.destroy()
			
		#build replacement string from list
		fullstring = string.join(allwords)
		#do edit, making it "undo"-able
		self.buffer.begin_user_action()
		self.buffer.delete(start,end)
		self.insert_data(fullstring)
		self.buffer.end_user_action()
		_dialogs.info('Spell check complete')
		
#**************************************************************************************************************
#Color Dialog -- insert HEX code for color at the insertion point
#***********************************************************************************************************
	def colorSelect(self, button=None):
		color = gtk.gdk.color_parse("blue")
		dialog = gtk.ColorSelectionDialog("Pick a color")
		dialog.set_transient_for(self)
		colorsel = dialog.colorsel
		
		colorsel.set_previous_color(color)
		colorsel.set_current_color(color)
		colorsel.set_has_palette(True)

		response = dialog.run()
		
		if response == gtk.RESPONSE_OK:
			color = colorsel.get_current_color()
			cRGB = (color.red / 256,color.green / 256,color.blue / 256)
			hexcolor = '"#%02x%02x%02x"' % cRGB
			self.insert_data(hexcolor)
		dialog.destroy()
		
	# needed for new combos (no convenience function to get active text in the combo)	
	def get_active_text(self, combobox):
		model = combobox.get_model()
		active = combobox.get_active()
		if active < 0:
			return None
		return model[active][0]
#**************************************************************************************************************

	def get_encoding(self, message):
		"Returns (encoding, errors), or raises Abort to cancel."
		box = gtk.MessageDialog(self, 0, gtk.MESSAGE_QUESTION, gtk.BUTTONS_CANCEL, message)
		#box.set_has_separator(False)

		frame = gtk.Frame()
		box.vbox.pack_start(frame, True, True)
		frame.set_border_width(6)
		hbox = gtk.HBox(False, 4)
		hbox.set_border_width(6)
		hbox.pack_start(gtk.Label('Encoding:'), False, True, 0)
	###########################
		combo = gtk.combo_box_new_text()
		for l in known_codecs:
			combo.append_text(l)
                combo.set_active(1)		
	###########################
		hbox.pack_start(combo, True, True, 0)
		ignore_errors = gtk.CheckButton('Ignore errors')
		hbox.pack_start(ignore_errors, False, True)

		frame.add(hbox)
		
		box.vbox.show_all()
		box.add_button(gtk.STOCK_CONVERT, gtk.RESPONSE_YES)
		box.set_default_response(gtk.RESPONSE_YES)

		while 1:
			resp = box.run()
			if resp != gtk.RESPONSE_YES:
				box.destroy()
				raise Abort

			if ignore_errors.get_active():
				errors = 'replace'
			else:
				errors = 'strict'
			encoding = self.get_active_text(combo)
			try:
				codecs.getdecoder(encoding)
				break
			except:
				_dialogs.alert(("Unknown encoding '%s'") % encoding)
			
		box.destroy()

		return encoding, errors
	
	def insert_data(self, data):
		import codecs
		errors = 'strict'
		encoding = 'utf-8'

		while 1:
			decoder = codecs.getdecoder(encoding)
			try:
				data = decoder(data, errors)[0]
				if errors == 'strict':
					assert '\0' not in data
				else:
					if '\0' in data:
						data = data.replace('\0', '\\0')
				break
			except:
				pass


			encoding, errors = self.get_encoding(
				("Data is not valid %s. Please select the file's encoding. "
				  "Turn on 'ignore errors' to try and load it anyway.")
				  % encoding)

		self.buffer.begin_user_action()
		self.buffer.insert_at_cursor(data)
		self.buffer.end_user_action()
		return 1
	

	def load_file(self, fname):
		if fname == '-':
 			try:
				file = sys.stdin  
				dat = file.read() 
				contents = self.convert_to_utf8(dat)
				
				self.insert_data(contents)
				return True
			except:
				dlg = gtk.MessageDialog(self, gtk.DIALOG_DESTROY_WITH_PARENT,
							gtk.MESSAGE_ERROR, gtk.BUTTONS_OK,
							"Can't open text from stdin")
				resp = dlg.run()
				dlg.hide()
				return False
					
    		else:
			if not os.path.exists(fname):
				dlg = gtk.MessageDialog(self, gtk.DIALOG_DESTROY_WITH_PARENT,
							gtk.MESSAGE_ERROR, gtk.BUTTONS_OK,
							"Can't find the file " + fname + "\n\nI\'ll be leaving now...")
				resp = dlg.run()
				dlg.hide()
				return False
			try:
				fd = open(fname)
				dat = fd.read()
				#convert to utf8
				buf = self.convert_to_utf8(dat)
				# bail if not possible
				if buf == None:
					dlg = gtk.MessageDialog(self, gtk.DIALOG_DESTROY_WITH_PARENT,
					gtk.MESSAGE_ERROR, gtk.BUTTONS_OK,
					"Can't open " + fname + "\n\nFile could not be converted to UTF8 using Python.")
					resp = dlg.run()
					dlg.hide()
					return False

				self.buffer.begin_not_undoable_action()
				while buf != '':
					self.buffer.insert_at_cursor(buf)
					buf = fd.read(BLOCK_SIZE)
					self.text.queue_draw()
				self.buffer.insert_at_cursor(buf)
				fd.close()
				self.text.queue_draw()
				self.uri = fname
				self.buffer.end_not_undoable_action()
				return True
			except:
				dlg = gtk.MessageDialog(self, gtk.DIALOG_DESTROY_WITH_PARENT,
							gtk.MESSAGE_ERROR, gtk.BUTTONS_OK,
							"Can't open " + fname + "\n\nFile could not be converted to UTF8 using Python.")
				resp = dlg.run()
				dlg.hide()
				return False


	def convert_to_utf8(self, raw):  

		for enc in known_codecs:  
			try:   
				data = raw.decode(enc)  
				break  
			except Exception:  
				if enc == known_codecs[-1]:  
					return None  
				continue 
 		return data
  
  
		
	def close(self, event = None, data = None):
		
		if self.buffer.get_modified():
			dia = gtk.Dialog('Save file?',self,
				gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
				("Yes, I\'ll save it", 99, gtk.STOCK_NO, gtk.RESPONSE_CLOSE))
			vbox = gtk.VBox()
			lbl1 = gtk.Label('The current file is not saved.\nWould you like to save that file now?')
			
			dia.vbox.pack_start(lbl1,False,False,12)
			dia.show_all()
			result = dia.run()
			dia.destroy()
			if result == 99:
				self.file_save(self)
			elif result == gtk.RESPONSE_CLOSE:
				gtk.main_quit()
			else:
				gtk.main_quit()
		else:
			gtk.main_quit()
		
#****************************************************************************************************************************
# Insertion Functions
#****************************************************************************************************************************			

	def inBreak(self, button = None):
		self.insert_data("<BR>")

	def inQuote(self, button = None):
		self.insert_data('&quot;')
		
	def inSpace(self, button = None):
		self.insert_data('&nbsp;')
		
	def inPre(self, button = None):
		self.insert_data('<pre>')
		
	def inPreEnd(self, button = None):
		self.insert_data('</pre>')
				
	def blkQuote(self, button = None):
		self.insert_data('<BLOCKQUOTE>')

	def blkCenter(self, button = None):
		self.insert_data('<CENTER>')
		
	def blkCenterEnd(self, button = None):
		self.insert_data('</CENTER>')
		
	def blkQuoteEnd(self, button = None):
		self.insert_data('</BLOCKQUOTE>')
		
	def java_script(self, button = None):
		self.insert_data('<script type="text/javascript">\n#### insert script here ####\n</script>')
		
	def style_tag(self, button = None):
		self.insert_data('<style type="text/css">\n### INSERT STYLE VALUES HERE ####\n</style>')
		
	def print_date(self, button = None):
		import datetime
		self.insert_data(datetime.datetime.now().strftime("%A, %m/%d/%Y") )		
		 
#*************************************************************************************************
		
	def discard(self):
		self.destroy()

	def up(self, button = None):
		if self.uri:
			filer.show_file(self.uri)
		else:
			_dialogs.alert(('File is not saved to disk yet'))

	def has_selection(self):
		s, e = self.get_selection_range()
		return not e.equal(s)
	
	def get_marked_range(self):
		s = self.buffer.get_iter_at_mark(self.mark_start)
		e = self.buffer.get_iter_at_mark(self.mark_end)
		if s.compare(e) > 0:
			return e, s
		return s, e

	def get_selection_range(self):
		s = self.buffer.get_iter_at_mark(self.insert_mark)
		e = self.buffer.get_iter_at_mark(self.selection_bound_mark)
		if s.compare(e) > 0:
			return e, s
		return s, e

	def save_to_stream(self, stream):
		s = self.buffer.get_start_iter()
		e = self.buffer.get_end_iter()
		stream.write(self.buffer.get_text(s, e, TRUE))
	
	def set_uri(self, uri):
		self.uri = uri
		self.buffer.set_modified(FALSE)
		self.update_title()
	
	def new(self):
		EditWindow()
	
	def change_font(self):
		style = self.text.get_style().copy()
		style.font = load_font(options.get('edit_font'))
		self.text.set_style(style)
	
	def set_marked(self, start = None, end = None):
		"Set the marked region (from the selection if no region is given)."
		self.clear_marked()
		assert not self.marked

		buffer = self.buffer
		if start:
			assert end
		else:
			assert not end
			start, end = self.get_selection_range()
		buffer.move_mark(self.mark_start, start)
		buffer.move_mark(self.mark_end, end)
		buffer.apply_tag_by_name('marked',
			buffer.get_iter_at_mark(self.mark_start),
			buffer.get_iter_at_mark(self.mark_end))
		self.marked = 1
	
	def clear_marked(self):
		if not self.marked:
			return
		self.marked = 0
		buffer = self.buffer
		buffer.remove_tag_by_name('marked',
			buffer.get_iter_at_mark(self.mark_start),
			buffer.get_iter_at_mark(self.mark_end))
	
	def undo(self, widget = None):
		self.buffer.undo()
	
	def redo(self, widget = None):
		self.buffer.redo()

	def goto(self, widget = None):
		from goto import Goto
		self.set_minibuffer(Goto())
	
	def search(self, widget = None):
		from search import Search
		self.set_minibuffer(Search())
	
	def search_replace(self, widget = None):
		from search import Replace
		Replace(self).show()
	
	def set_mini_label(self, label):
		self.mini_label.set_text(label)

	def set_minibuffer(self, minibuffer):
		assert minibuffer is None or isinstance(minibuffer, Minibuffer)

		self.minibuffer = None

		if minibuffer:
			self.mini_entry.set_text('')
			self.minibuffer = minibuffer
			minibuffer.setup(self)
			self.mini_entry.grab_focus()
			self.mini_hbox.show_all()
		else:
			self.mini_hbox.hide()
			self.text.grab_focus()
	
	def mini_key_press(self, entry, kev):
		if kev.keyval == gtk.keysyms.Escape:
			self.set_minibuffer(None)
			return 1
		if kev.keyval == gtk.keysyms.Return or kev.keyval == gtk.keysyms.KP_Enter:
			self.minibuffer.activate()
			return 1

		return self.minibuffer.key_press(kev)
	
	def mini_changed(self, entry):
		if not self.minibuffer:
			return
		self.minibuffer.changed()

	def mini_show_info(self, *unused):
		assert self.minibuffer
		if self.info_box:
			self.info_box.destroy()
		self.info_box = gtk.MessageDialog(self, 0, gtk.MESSAGE_INFO, gtk.BUTTONS_OK,
						self.minibuffer.info)
		self.info_box.set_title(('Minibuffer help'))
		def destroy(box):
			self.info_box = None
		self.info_box.connect('destroy', destroy)
		self.info_box.show()
		self.info_box.connect('response', lambda w, r: w.destroy())
	
	def process_selected(self, process):
		"""Calls process(line) on each line in the selection, or each line in the file
		if there is no selection. If the result is not None, the text is replaced."""
		self.buffer.begin_user_action()
		self._process_selected(process)
		self.buffer.end_user_action()
	
	def _process_selected(self, process):
		if self.has_selection():
			def get_end():
				start, end = self.get_selection_range()
				if start.compare(end) > 0:
					return start
				return end
			start, end = self.get_selection_range()
			if start.compare(end) > 0:
				start = end
		else:
			def get_end():
				return self.buffer.get_end_iter()
			start = self.buffer.get_start_iter()
		end = get_end()

		while start.compare(end) <= 0:
			line_end = start.copy()
			line_end.forward_to_line_end()
			if line_end.compare(end) >= 0:
				line_end = end
			line = self.buffer.get_text(start, line_end, False)
			new = process(line)
			if new is not None:
				self.buffer.move_mark(self.mark_tmp, start)
				self.buffer.insert(line_end, new)
				start = self.buffer.get_iter_at_mark(self.mark_tmp)
				line_end = start.copy()
				line_end.forward_chars(len(line))
				self.buffer.delete(start, line_end)
				
				start = self.buffer.get_iter_at_mark(self.mark_tmp)
				end = get_end()
			if not start.forward_line(): break
				
				
	def getRelPath(self, target):
		"""
		Return a relative path to the target from current document directory.
		"""
		base=os.path.dirname(self.uri)
		
		base_list = (os.path.abspath(base)).split(os.sep)
		target_list = (os.path.abspath(target)).split(os.sep)

		# On the windows platform the target may be on a completely different drive from the base.
		if os.name in ['nt','dos','os2'] and base_list[0] <> target_list[0]:
			raise OSError, 'Target is on a different drive to base. Target: '+target_list[0].upper()+', base: '+base_list[0].upper()

		# Starting from the filepath root, work out how much of the filepath is shared by base and target.
		for i in range(min(len(base_list), len(target_list))):
			if base_list[i] <> target_list[i]: break
		else:
			# If we broke out of the loop, i is pointing to the first differing path elements.
			# If we didn't break out of the loop, i is pointing to identical path elements.
			# Increment i so that in all cases it points to the first differing path elements.
			i+=1

		rel_list = [os.pardir] * (len(base_list)-i) + target_list[i:]
		return os.path.join(*rel_list)


	def istext(self, s):
		text_characters = "".join(map(chr, range(32, 127)) + list("\n\r\t\b"))
		_null_trans = string.maketrans("", "")
		if "\0" in s:
			return 0
		if not s:  # Empty files are considered text
			return 1
		# Get the non-text characters (maps a character to itself then
		# use the 'remove' option to get rid of the text characters.)
		t = s.translate(_null_trans, text_characters)
		# If more than 30% non-text characters, then this is considered a binary file
		if len(t)/len(s) > 0.30:
			return 0
		return 1
		

#****************************************************************************************************************************
# Open a New Document... again, nothing fancy, just open another instance or app passing filename...
#*************************************************************************************************
	def newdoc(self, button = None):
		cmd = 'htmlpage %s' % "_new"
		os.system(cmd)

#****************************************************************************************************************************
# Open A File (No Class)
#****************************************************************************************************************************		

	def ok_file_btn_clicked(self, w):
		# if we get returned a Directory or a file which does not exist, keep waiting...
		if os.path.isdir(w) or not os.path.isfile(w):
			return
		if not os.access(w, os.W_OK):
			_dialogs.alert("You do not have write access to that file")
			return
		args = [prog_cmd, w]
		os.spawnv(os.P_NOWAIT, prog_cmd, args)
		self.file_sel.destroy()


	def open(self, button = None):

		self.file_sel = gtk.FileChooserDialog("Open..", self,
						gtk.FILE_CHOOSER_ACTION_OPEN,
						(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
						gtk.STOCK_OPEN, gtk.RESPONSE_OK))
		self.file_sel.set_default_response(gtk.RESPONSE_OK)
		if self.uri:
			self.file_sel.set_current_folder(os.path.dirname(self.uri))
		else:
			self.file_sel.set_current_folder(os.path.expanduser("~/"))

		filter = gtk.FileFilter()
		filter.set_name("HTML")
		filter.add_mime_type("text/html")
		filter.add_pattern("*.shtml")
		filter.add_pattern("*.html")
		filter.add_pattern("*.htm")
		self.file_sel.add_filter(filter)
		
		filter = gtk.FileFilter()
		filter.set_name("All files")
		filter.add_pattern("*")
		self.file_sel.add_filter(filter)

		response = self.file_sel.run()
		if response == gtk.RESPONSE_OK:
			self.ok_file_btn_clicked(self.file_sel.get_filename())
		elif response == gtk.RESPONSE_CANCEL:
			self.file_sel.destroy()

	
#***********************************************************************************************************
#  File save routines
#***********************************************************************************************************

	def file_save(self, evt):
		if self.buffer.get_modified() and self.uri:
			# has uri but changed, so resave
			if self.write_file(self.uri):
				box = gtk.MessageDialog(None, 0, gtk.MESSAGE_INFO, gtk.BUTTONS_OK, "\nFile has been saved")
				box.set_position(gtk.WIN_POS_MOUSE)
				box.set_title('Success')
				box.run()
				box.destroy()
			
		elif not self.uri:
			# no path yet, so open save as...
			self.save_file_dialog()
		else:
			ot = os.stat(self.uri)[stat.ST_MTIME]
			since_saved = self.time_diff(ot)
			_dialogs.info('The current file:\n%s\nhas not been changed since it was last saved.\n%s' % (self.uri, since_saved))	
		
	def save_file_dialog(self, event=None):

		self.savedlg = gtk.FileChooserDialog("Save As..", self,
						gtk.FILE_CHOOSER_ACTION_SAVE,
						(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
						gtk.STOCK_SAVE, gtk.RESPONSE_OK))
		self.savedlg.set_default_response(gtk.RESPONSE_OK)
		if self.uri:
			self.savedlg.set_current_folder(os.path.dirname(self.uri))
			self.savedlg.set_current_name(os.path.basename(self.uri))
		else:
			self.savedlg.set_current_folder(os.path.expanduser("~/"))
			self.savedlg.set_current_name("untitled.html")
		
		
		filter = gtk.FileFilter()
		filter.set_name("HTML")
		filter.add_mime_type("text/html")
		filter.add_pattern("*.html")
		filter.add_pattern("*.htm")
		self.savedlg.add_filter(filter)
		
		filter = gtk.FileFilter()
		filter.set_name("All files")
		filter.add_pattern("*")
		self.savedlg.add_filter(filter)

		response = self.savedlg.run()
		if response == gtk.RESPONSE_OK:
			self.check_file(self.savedlg.get_filename())
			self.savedlg.destroy()
		elif response == gtk.RESPONSE_CANCEL:
			self.savedlg.destroy()
		
		
		
	def check_file(self, f):
		if not f:
			return
		if os.path.exists(f):
			dia = gtk.Dialog('OVERWRITE?',self,
				gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
				("Overwrite it.", 77, gtk.STOCK_CANCEL, gtk.RESPONSE_CLOSE))
			vbox = gtk.VBox()
			lbl1 = gtk.Label('The file:\n%s\nalready exists.\n\nDo you want to overwrite the old file?' % f)
			
			dia.vbox.pack_start(lbl1,False,False,12)
			dia.show_all()
			result = dia.run()
			dia.destroy()
			if result == 77:
				self.write_file(f)
			elif result == gtk.RESPONSE_CLOSE:
				return
		else:
			self.write_file(f)
			
	def write_file(self, fname):
		try:
			start, end = self.buffer.get_bounds()
			blockend = start.copy()
			fd = open(fname, "w")
			while blockend.forward_chars(BLOCK_SIZE):
				buf = self.buffer.get_text(start, blockend)
				fd.write(buf)
				start = blockend.copy()
			buf = self.buffer.get_text(start, blockend)
			fd.write(buf)
			fd.close()
			self.buffer.set_modified(False)
			self.uri = fname
			self.update_title()
			return True
		except:
			dlg = gtk.MessageDialog(self, gtk.DIALOG_DESTROY_WITH_PARENT,
				gtk.MESSAGE_ERROR, gtk.BUTTONS_OK,
 				"Error saving file " + fname)
			resp = dlg.run()
			dlg.hide()		
#***********************************************************************************************************
#***********************************************************************************************************
#  HTML-ify -- Next 3 functions:
#             ManageSpecialChars, makeURLs and parseText --
#             attempt to convert plain text to HTML. Work on selected text
#
#      BELOW that, the editede versions of some of these functions are used for TABLE-ify
#***********************************************************************************************************
#***********************************************************************************************************
		
		
	def ManageSpecialChars(self, chars, subIndex, f):
		sChar=chars[subIndex]
		if sChar == ' ':
			if subIndex<1:
				pass
			else:
				lastChar=chars[subIndex-1]
				if lastChar == ' ':
					f.write('&nbsp;')
				elif lastChar=='\n':
					f.write('\n<P>\n')
				else:
					f.write(' ');
		elif sChar == '\t':
			x=0
			while x<4:
				f.write('&nbsp;')
				x += 1
		elif sChar == '<':
			f.write('&lt;')
		elif sChar == '>':
			f.write('&gt;')
		elif sChar == '&':
			f.write('&amp;')
		elif sChar == '"':
			f.write('&quot;')
		else:
			return 0

		return 1


	def makeURLs(self):

		t2 = open("htmlpage_tmp", "r")
		urlStr=t2.read()
		newdata = re.sub(r"""(?x)
		(  # Start of group 1
		(http|https|ftp|mailto)  # URL scheme
		:                  # Separating colon
		\S+                # Everything up to the next whitespace character
		)  # End of group 1
		""", r'<a href="\g<1>">\g<1></a>', urlStr)
	
		t2.close()
		os.system('rm -f %s' % "htmlpage_tmp")
		return newdata
	


	def parseText(self, button=None):
		#check for a selection, put in "mytext" if found
		if not self.buffer.get_selection_bounds():
			_dialogs.alert("No text has been selected...\n\nthe HTML-ify function will check highlighted \ntext, not the entire document.")
			return
		start, end = self.buffer.get_selection_bounds()
		myStr = self.buffer.get_text(start,end)
		if len(myStr) < 2:
			_dialogs.alert("\nNot much to convert...")
			return
		myIndex=0
		inpara=0
		t1 = open("htmlpage_tmp", "w")
		while myIndex < len(myStr):
			c=myStr[myIndex]
			if self.ManageSpecialChars(myStr, myIndex, t1):
				pass
			elif c == '\n':
				#get next character 
				myIndex=myIndex + 1
				c=myStr[myIndex]
				#if next character is also a newline, then we
				#need to supply para start/end tags
				if c == '\n':
					if inpara:
						t1.write('\n</P>\n')
						inpara=0
					else:
						t1.write('\n<P>\n')
						inpara=1
				else:
					#not a newline
					#write a line-break tag for the first newline
					t1.write('\n<BR>\n')
					if not self.ManageSpecialChars(myStr, myIndex, t1):
						t1.write(c)
			else:
				#normal character
				t1.write(c)
			#get next character
			myIndex=myIndex + 1
	
		t1.close()
		#build replacement string from makeURLs return value
		fullstring = self.makeURLs()
		#do edit, making it "undo"-able
		self.buffer.begin_user_action()
		self.buffer.delete(start,end)
		self.insert_data(fullstring)
		self.buffer.end_user_action()
		_dialogs.info('HTML-ify is complete')

		
#***********************************************************************************************************
#  TABLE-ify
#***********************************************************************************************************	


	def parseTable(self, button=None):
		#check for a selection, put in "mytext" if found
		if not self.buffer.get_selection_bounds():
			_dialogs.alert("\nNo text has been selected...\n\nthe TABLE-ify function will check highlighted \ntext, not the entire document.")
			return
		start, end = self.buffer.get_selection_bounds()
		myStr = self.buffer.get_text(start,end)
		if len(myStr) < 2:
			_dialogs.alert("\nNot much to work with...")
			return
		if myStr.count( '\t' ) < 2:
			_dialogs.info("\nNot much of a table there... \nbut OK")
		
		myIndex=0

		t1 = open("htmlpage_tmp", "w")
		
		t1.write('<TABLE border=1>\n<TR><TD>')
		
		while myIndex < len(myStr):
			c=myStr[myIndex]
			if self.ManageSpecialChars2(myStr, myIndex, t1):
				pass
			elif c == '\n':
				#
				# need to check if another newline comes before the next tab
				#
				tmpIndex = myIndex
				while tmpIndex < len(myStr) - 1:
					tmpIndex = tmpIndex + 1
					d=myStr[tmpIndex]
					if d == '\n': # another newline before a tab, so we put a break
						t1.write('<BR>')
						break
					elif d == '\t':
						t1.write('</TD></TR>\n<TR><TD>')
						break
					else:
						pass
						
			elif c == '\t':
				t1.write('</TD><TD>')
			else:
				#normal character
				t1.write(c)
			#get next character
			myIndex=myIndex + 1
	
		t1.write('</TD></TR>\n</TABLE>')
		
		t1.close()
		#build replacement string from makeURLs return value
		fullstring = self.makeURLs()
		#do edit, making it "undo"-able
		self.buffer.begin_user_action()
		self.buffer.delete(start,end)
		self.insert_data(fullstring)
		self.buffer.end_user_action()
		_dialogs.info('TABLE-ify is complete')
		
		
		
	def ManageSpecialChars2(self, chars, subIndex, f):
		sChar=chars[subIndex]
		if sChar == ' ':
			if subIndex<1:
				pass
			else:
				lastChar=chars[subIndex-1]
				if lastChar == ' ':
					f.write('&nbsp;')
			#	elif lastChar=='\n':
			#		f.write('\n<P>\n')
				else:
					f.write(' ')
		elif sChar == '<':
			f.write('&lt;')
		elif sChar == '>':
			f.write('&gt;')
		elif sChar == '&':
			f.write('&amp;')
		elif sChar == '"':
			f.write('&quot;')
		else:
			return 0

		return 1
				
		
#***********************************************************************************************************
# End of TABLE-ify
#***********************************************************************************************************	
	def time_diff(self, old_time):
		diff = time.time() - old_time
		if diff > 86400:
			diff = int(diff / 86400)
			return  str(diff)
		elif diff > 3600:
			hrs = str(int(diff / 3600))
			mins = str(int(diff % 60))
			return  str('%s hour(s)s, %s min(s) ago' % (hrs, mins))
		elif diff > 60:
			mins = str(int(diff / 60))
			return  str('%s min(s) ago' % mins)
		else:
			sec = str(int(diff))
			return  str('\n    %s seconds(s) ago' % sec)	
			
				
	def show_help(self, event=None):
		import help
		help.help_window()


	def get_img_dim(self, f):		
		try:
			pixbuf=gtk.gdk.pixbuf_new_from_file(f)	
			width=float(pixbuf.get_width())
			height=float(pixbuf.get_height())
			wh = [width, height]
			return wh
		except:
			pass

#**************************************************************************************************************
#Color Dialog BG -- change textview BG, insert HEX into config file
#***********************************************************************************************************
	def txt_bg_color(self, button=None):
		color = gtk.gdk.color_parse("blue")
		dialog = gtk.ColorSelectionDialog("Pick a color")
		dialog.set_transient_for(self)
		colorsel = dialog.colorsel
		
		colorsel.set_previous_color(color)
		colorsel.set_current_color(color)
		colorsel.set_has_palette(True)

		response = dialog.run()
		
		if response == gtk.RESPONSE_OK:
			color = colorsel.get_current_color()
			cRGB = (color.red / 256,color.green / 256,color.blue / 256)
			hexcolor = '#%02x%02x%02x' % cRGB
			config.set("defaults", "background_colour", hexcolor)
			t1 = open(cfile, "w")
			config.write(t1)
			t1.close()
			self.text.modify_base(gtk.STATE_NORMAL, color)
		dialog.destroy()
#**************************************************************************************************************
#Color Dialog FG -- change textview FG, insert HEX into config file
#***********************************************************************************************************
	def txt_fg_color(self, button=None):
		color = gtk.gdk.color_parse("blue")
		dialog = gtk.ColorSelectionDialog("Pick a color")
		dialog.set_transient_for(self)
		colorsel = dialog.colorsel
		
		colorsel.set_previous_color(color)
		colorsel.set_current_color(color)
		colorsel.set_has_palette(True)

		response = dialog.run()
		
		if response == gtk.RESPONSE_OK:
			color = colorsel.get_current_color()
			cRGB = (color.red / 256,color.green / 256,color.blue / 256)
			hexcolor = '#%02x%02x%02x' % cRGB
			config.set("defaults", "foreground_colour", hexcolor)
			t1 = open(cfile, "w")
			config.write(t1)
			t1.close()
			self.text.modify_text(gtk.STATE_NORMAL, color)
		dialog.destroy()
#**************************************************************************************************************
	def select_font(self, button):
		fdlg = gtk.FontSelectionDialog("Font Selection Dialog")
		fdlg.set_position(gtk.WIN_POS_MOUSE)
		fdlg.set_font_name(config.get("defaults", "default_font"))
		response = fdlg.run()
		if response == gtk.RESPONSE_OK:
			fname = fdlg.get_font_name()
			config.set("defaults", "default_font", fname)
			t1 = open(cfile, "w")
			config.write(t1)
			t1.close()
			font = pango.FontDescription(fname)
			self.text.modify_font(font)
		elif response == gtk.RESPONSE_CANCEL:
			pass
		fdlg.destroy()
		
