#!/usr/bin/env python
#################################################################################
# c2005-2015 by Paul Sherman                                                    #
# <psherma1@rochester.rr.com> http://www.pcbypaul.com                           #
#									        #
# This program is free software; you can redistribute it and/or			#
# modify it under the terms of the GNU General Public License			#
# as published by the Free Software Foundation; either version 3		#
# of the License, or (at your option) any later version.			#
#										#
# This program is distributed in the hope that it will be useful,		#
# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the			#
# GNU General Public License for more details.					#
#										#
# You should have received a copy of the GNU General Public License		#
# along with this program; if not, write to the Free Software			#
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.   #
#################################################################################
##  importing with system requirement checks ####################################

import string, sys, os
import pygtk
#pygtk.require('2.0') # eliminated due to errors when used with cx_freeze
import gtk
import gobject
import time
import EditWindow
import urllib2

if gobject.pygtk_version < (2,3,96):
    print >>sys.stderr, "pyGTK version 2.4 or greater is required for this application"
    raise SystemExit


# Load icons #####################################################################
factory = gtk.IconFactory()
for name in ['table', 'insert', 'effect', 'font_color', 'calendar', 'bg_color']:

	path = os.path.join(os.path.dirname(os.path.realpath(sys.argv[0])), "images", name + ".png")
	try:
		pixbuf = gtk.gdk.pixbuf_new_from_file(path)
		gtk.stock_add([(name, name, 0, 0, "")])
		factory.add(name, gtk.IconSet(pixbuf = pixbuf))
		factory.add_default()

	except:
		print >>sys.stderr, "Can't load stock icon '%s'" % name

def get_page(url):
	try:
		page = urllib2.urlopen(url)
	except urllib2.URLError:
		return ''
	body = page.read()
	page.close()
	return body

def not_found(f):
	dlg = gtk.MessageDialog(None, gtk.DIALOG_DESTROY_WITH_PARENT,
		gtk.MESSAGE_ERROR, gtk.BUTTONS_OK,
 		"FFFFILE NOT FOUNDDDDDDD")
	resp = dlg.run()
	dlg.hide()
	raise SystemExit	
	

# import EditWindow ##############################################################
#
# to open a passed file... 
# live stuff gets saved to tmp directory before opened
# the extensive conditionals handle missing files and filenames with spaces
#
	
if len(sys.argv) > 1:
	
	if sys.argv[1] == "_new" or sys.argv[1] == "DUH":
		EditWindow.EditWindow()
	else:
	
		for file in sys.argv[1:]:
			# this line eliminates any "name" references passed from a filename 
			# ex. index.html#sectioname
			file = string.split(file, '#' )[0]
			if not os.path.exists(file):
				file_str = string.join(sys.argv[1:])
				data = get_page(file)
				if data == '':
					not_found(file)
				try:
					EditWindow.EditWindow('', data)
				except  EditWindow.Abort:
					not_found(file)	
			else:

				try:
					EditWindow.EditWindow(file)
				except  EditWindow.Abort:
					not_found(file)
					
elif len(sys.argv) == 1:

	if sys.argv[0] == "./HTMLpage.py":
		EditWindow.EditWindow()
	else:
		file = string.split(sys.argv[0], '#' )[0]
		if not os.path.exists(file):
			file_str = string.join(sys.argv[0])
			data = get_page(file)
			if data == '':
				not_found(file)
			try:
				EditWindow.EditWindow('', data)
			except  EditWindow.Abort:
				not_found(file)	
else:
	
	try:
		EditWindow.EditWindow()
	except:
		dlg = gtk.MessageDialog(None, gtk.DIALOG_DESTROY_WITH_PARENT,
			gtk.MESSAGE_ERROR, gtk.BUTTONS_OK,
 			"Errors were encountered and aborted")
		resp = dlg.run()
		dlg.hide()
		raise SystemExit		

gtk.main()
