import gtk
from EditWindow import Minibuffer

class Goto(Minibuffer):
	"A minibuffer used to find a line by number."

	def setup(self, window):
		self.window = window
		self.window.set_mini_label(('Goto line:'))
	
	info = ('Enter the line number to go to. Line numbers start from 1. '
		 'Press Escape to cancel, or Return to jump to the line.')
	
	def activate(self):
		line = self.window.mini_entry.get_text()
		if line:
			try:
				line = int(line)
				assert line >= 1
			except:
        			dialog = gtk.MessageDialog(self.window, 0, gtk.MESSAGE_ERROR, gtk.BUTTONS_OK, "\nInvalid line number: '%s'" % line)
        			dialog.set_default_response(gtk.BUTTONS_OK)
        			dialog.run()
        			dialog.destroy()
        			return
			else:
				buffer = self.window.buffer
				iter = buffer.get_iter_at_line(line - 1)
				buffer.place_cursor(iter)
				self.window.text.scroll_to_iter(iter,0.05, gtk.FALSE)
		self.window.set_minibuffer(None)
