import pygtk
import gtk
import os
import sys

class help_window(gtk.Window):

	
	def delete_event(self, event=None):
		self.destroy()
		
		
	def __init__(self):
		gtk.Window.__init__(self, gtk.WINDOW_TOPLEVEL)
		
		self.connect("destroy", self.delete_event)

        	self.set_title('(mostly) Helpful Information')

		self.set_border_width(0)
		self.set_size_request(500, 450)

		try:
			IMAGEDIR = os.path.join(os.path.dirname(os.path.realpath(sys.argv[0])), 'images/')
			ME_IMAGE = os.path.join(IMAGEDIR, 'me.jpg')
		except:
			pass
		
		box1 = gtk.VBox()
		self.add(box1)
		box1.show()

		box2 = gtk.VBox(spacing=4)
		box2.set_border_width(4)
		box1.pack_start(box2)
		box2.show()

		notebook = gtk.Notebook()
		notebook.set_tab_pos(gtk.POS_TOP)
		box2.pack_start(notebook)
		notebook.show()

		names = ['About', 'Drag N Drop', 'Spelling', 'HTML-ify', 'TABLE-ify', 'Kbd Shortcuts', 'Authors']
		msg = self.mlist()
		
		for i in range(len(names)):
			buffer = names[i]
			frame = gtk.Frame(buffer)
			frame.set_border_width(10)
			frame.set_size_request(400, 376)
			frame.set_shadow_type(gtk.SHADOW_ETCHED_OUT)
			frame.show()
		    
			############################################################################
			# add widgets to each frame here
			if i == 0:
				label = gtk.Label(msg[i])
				frame.add(label)
				label.show()
			if i == 1:
				label = gtk.Label(msg[i])
				frame.add(label)
				label.show()
			if i == 2:
				label = gtk.Label(msg[i])
				frame.add(label)
				label.show()
			if i == 3:
				label = gtk.Label(msg[i])
				frame.add(label)
				label.show()
			if i == 4:
				label = gtk.Label(msg[i])
				frame.add(label)
				label.show()
			if i == 5:
				label = gtk.Label(msg[i])
				frame.add(label)
				label.show()
			if i == 6:
			
				image = gtk.Image()

				# use the current directory for the file
				try:
					pixbuf = gtk.gdk.pixbuf_new_from_file(ME_IMAGE)
					image.set_from_pixbuf(pixbuf)

				except:
					print >>sys.stderr, "Can't load Me picture "

				#label = gtk.Label(str(i))
				
				label = gtk.Label(msg[i])
				
				box_me = gtk.VBox()
				box_me.pack_start(image)
				box_me.pack_start(label)
				image.show()
				label.show()
				box_me.show()
				
				frame.add(box_me)
							
			###########################################################################
		    
			label = gtk.Label(buffer)
			label.set_padding(2, 2)
		    
			# add list of added widgets to append_page ################################
			notebook.append_page(frame, label)
		    

		#separator = gtk.HSeparator()
		#box1.pack_start(separator)
		#separator.show()

		box3 = gtk.VBox(spacing=4)
		box3.set_border_width(4)
		box1.pack_start(box3)
		box3.show()

		button = gtk.Button(label='CLOSE')
		box3.pack_start(button)
		button.connect('clicked', self.delete_event)
		button.show()

		self.show()
		
	def mlist(self):
		msglist = [""]
		msg1 = """HTMLpage version 2.5\n\n(c) 2005-2015 by Paul Sherman\n
HTMLpage (HTML Python And Gtk Executable) is a text-based HTML editor 
written in Python, using GTK and the pyGTK bindings. The use of some 
of the features and shortcuts are explained in subsequent tabs. 
(Don't look at Me)

Dependencies include:
    python >= 2.5
    GTK >= 2.14.1
    pyGTK >= 2.12.1
    pygobject >= 2.15.4
    pygtksourceview >= 2.3
    aspell >= 0.60 (Optional -- if you want spell checking)
  

Any questions/concerns regarding the program can be directed to
me at <psherman2001@gmail.com>

My webite is located at <http://www.pcbypaul.com>"""

		msg2 = """Program accepts dropped text-based files and images.
For dropped files, the program will determine 
the filetype and react accordingly.
	
IMAGES
    The program will accept jpg, png or gif images.
    Page must be saved first to generate relative paths.
    Tags created insert appropriate path and sizes such as:
    <img src="images/me.jpg" width="400" height="320" border=0>
    
FILES
    A dropped file will pop up a menu with three choices:
    
    	OPEN IN A NEW WINDOW
		Opens the file in a new instance of the program.
		This is an SDI (single document interface.)
		
	CREATE A HYPERLINK
		Creates a hyperling with a relative path to the dropped file.
		Like images, the page you drop onto must be saved first.
		<a href="path/to/example.html">example.html</a>
		
	INSERT TEXT AT CURSOR
         	Inserts the text from the dropped file into the current page. """

		msg3 = """Spell checking is dependent upon aspell. 
If aspell is not installed, spell-checking will be disabled. 


The spell checking works on SELECTED TEXT.

   This means you have to highlight the section of words you want to check.
   Usually I do a paragraph or a section at a time. This avoids 
   any conflicts with the HTML markup.
   
   Sounds awkward, but works great when you drop in large 
   sections of text. Run a spell-ckeck on a dropped or 
   pasted section, then HTML-ify it.
   
   Simple.
"""
		
		msg4 = """EASY WAY to make plain text render properly on an HTML page. 

Uses the simplest HTML tags (<BR> and &nbsp;) to produce the 
minimal amount of code to make paragraphs and indents look like, 
well -- paragraphs and indents. (There is a Perl script floating 
around called HTML-ify, but the algorithm I wrote is quite different.)

Especially helpful for long passages of simple text.

** Also produces clickable HYPERLINKS from URLs ***


HINT 1:

    If spell checking is desired, 
    run spell check first on the text before you HTML-ify it.
    
    
HINT 2:

    If you pasted a TABLE onto the page,
    run TABLE-ify on that section SEPARATELY.
"""
		msg5 = """COPYING a table from another HTML page
or from a different type of document (Word, OpenOfffice, Abi, KWord, etc)
can be a real hassle. And even when it "works" you get all kinds of 
cryptic markup in your HTML code.
NOT HERE

TABLE-ify makes a very simple table, with just the basic table tags.
It WILL create HYPERLINKS and it will parse multiple-line cell entries.


TO USE:
    Copy the table you want DIRECTLY FROM the other document -- 
    just highlight the table and click COPY or <Ctrl>+C
  
    then paste it into the page you're working on. The items in the "table" 
    will just be tab separated (and may look like a mess.) 
    No problem.
    
    Highlight what you just pasted in and click TABLE-ify...
    and a new table is born.
"""
		msg6 = """Also called "Accelerator keys" by us programming types.

  BASIC
  
  	Save                <Ctrl> + S
	Open               <Ctrl> + O
	New                <Ctrl> + N
	Find                <Ctrl> + F
	Replace           <Ctrl> + R
  
  
  INSERT (special characters +)
  
      <BR>                            <Ctrl> + B
      &nbsp;                          <alt><Ctrl> + B
      &quot;                          <Ctrl> + Q
      <pre>                          <Ctrl> + P
      </pre>                          <Ctrl><alt> + P
      <BLOCKQUOTE>         <Ctrl> + K
      </BLOCKQUOTE>        <alt><Ctrl> + K
      Javascript tag               <Ctrl> + J
      
  
"""
		msg7 = """As warped as they are good-looking . . ."""		
		
		msglist.insert(0,msg1)
		msglist.remove("")
				
		msglist.insert(1,msg2)
		msglist.insert(2,msg3)
		msglist.insert(3,msg4)
		msglist.insert(4,msg5)
		msglist.insert(5,msg6)
		msglist.insert(6,msg7)
		return msglist
		
	def main(self):
		gtk.main()

if __name__ == "__main__":
    w = help_window()
    w.main()

